Subject: Re: [-SPAM-] [PATCH RFC v7 00/22] Modernize the build system

From: Patrick Steinhardt <[email-masked]>
Date: Mon, 18 Nov 2024 10:30:44 +0100

On Sat, Nov 16, 2024 at 01:23:19AM +0000, Ramsay Jones wrote:
> On 15/11/2024 07:21, Patrick Steinhardt wrote:
> [snip]
> > Changes in v7:
> > 
> >   - Fix overriding TEST_OUTPUT_DIRECTORY via the environment.
> > 
> >   - Rework generation of version information. GIT-VERSION-GEN now knows
> >     to replace @PLACEHOLDERS@ in other files, and this gets used across
> >     Makefiles, CMake and Meson now. This makes us properly rebuild when
> >     the version info changes and fixes the version numbers in "git.rc".
> > 
> >   - The CMake build instructions are now doing a proper out-of-tree
> >     build.
> > 
> >   - We now generate and install gitweb.js, which gets built via a new
> >     "generate-gitweb-js.sh".
> > 
> >   - Some improvements to the Meson documentation.
> > 
> >   - Wire up DEVELOPER=1 style warnings via `--warnlevel 2` and above.
> > 
> >   - Wire up sanitizers properly.
> > 
> >   - Provide a new "regex" option to disable the platform-provided
> >     version of regcomp() et al.
> 
> Hmm, OK, but what about all the other 'configurations'?

I don't think it makes sense to introduce a separate option for every
single bit of the build process that can be changed. One of the biggest
differences compared to our Makefile is that Meson should be able to
automatically figure out the build environment and set up the build
accordingly, without any user interaction. So in the best case, whenever
we learn that a system does not work out of the box we'd not introduce
an option for this, but instead adapt the autoconfiguration logic to
detect that.

Now there will be exceptions where it does make sense to make something
a build option, due to whatever reason. But I'm in the camp of adding
them as-needed and not proactively so that we don't end up with hundreds
of options.

> >   - Stop installing git-http-backend into bindir.
> > 
> >   - Install Perl scripts into libexecdir.
> > 
> >   - Install git-cvsserver into bindir and libexecdir.
> > 
> >   - Install template directory into datadir.
> > 
> > As before, the tip of this patch series catches up with what is
> > happening in "seen". If you want to test it without topics in "seen" you
> > have to revert it.
> > 
> 
> Just a quick note to say that I tested this on Linux and Cygwin (just build)
> and noticed a few things:
> 
>   - 'make clean' does not delete the 'version-def.h' file.

This works now with the latest option.

>   - the RUNTIME_PREFIX set in the GIT-BUILD-OPTIONS file on the master
>     branch is not the same as on this 'meson-v7' branch (patches 1-21
>     based on current master branch):
> 
[snip]
> 
> Note that master has RUNTIME_PREFIX='false' rather than being un-set.
> (Indeed, the Makefile on the master branch normalizes the value of
> RUNTIME_PREFIX to 'true' or 'false').

Ah, good catch, corrected.

>     - The format of the GIT-BUILD-OPTIONS file generated by the Makefile
>       and meson are formatted differently, so you have to massage the
>       top-level file to be able to diff them:
> 
[snip]
> 
> Note that the Makefile build on Linux does not, by default, build with
> libpcre, even if the library is installed on the system (as it is for me).

I think building with libpcre by default does make sense though. I guess
that we don't with our Makefile because it's not doing autodetection of
available features in the first place, so it was safer to not compile
with the library by default.

> Also, note the values of BROKEN_PATH_FIX.

I've wired up the SANE_TOOL_PATH option properly now.

Thanks for your feedback!

Patrick